=== debian/changelog ===
openvpn (2.6.15-1ubuntu1) resolute; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - d/control: Demote easy-rsa to Suggests (universe package).
    - debian/openvpn@.service: Add '--script-security 2' similar to what
      got added to debian/openvpn.init.d ages ago (LP #1454725)
    - d/t/control: Move to isolation-container to enable armhf/LXD coverage.
      (LP #2104146)

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 27 Oct 2025 18:54:34 +0100

openvpn (2.6.15-1) unstable; urgency=medium

  * New upstream version 2.6.15 (Closes: #1118074)
    - Drop Kernel 6.16+ fix applied upstream

 -- Bernhard Schmidt <berni@debian.org>  Sun, 26 Oct 2025 16:32:43 +0100

openvpn (2.6.14-2ubuntu1) questing; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - d/control: Demote easy-rsa to Suggests (universe package).
    - debian/openvpn@.service: Add '--script-security 2' similar to what
      got added to debian/openvpn.init.d ages ago (LP #1454725)
    - d/t/control: Move to isolation-container to enable armhf/LXD coverage.
      (LP #2104146)
    - d/p/handle_intentional_route_push_float_ip.patch

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 06 Sep 2025 08:40:39 +0200

openvpn (2.6.14-1ubuntu2) questing; urgency=medium

  * d/p/handle_intentional_route_push_float_ip.patch: Fix floating IP due
    to "route VPN_IP net_gateway", which can lead to incorrect blocking of
    a source IP switch for 60 seconds immediately after connection setup.
    (LP: #2108860)

 -- Bryce Harrington <bryce@canonical.com>  Thu, 28 Aug 2025 15:34:24 -0700

openvpn (2.6.14-1ubuntu1) questing; urgency=medium

  * Merge from Debian Unstable (LP: #2110417). Remaining changes:
    - d/control: Demote easy-rsa to Suggests (universe package).
    - debian/openvpn@.service: Add '--script-security 2' similar to what
      got added to debian/openvpn.init.d ages ago (LP #1454725)
    - d/t/control: Move to isolation-container to enable armhf/LXD coverage.
      (LP #2104146)
  * Dropped Changes:
    - SECURITY UPDATE: denial of service issue
      + debian/patches/CVE-2025-2704.patch: allow tls-crypt-v2 to be setup
        only on initial packet of a session in src/openvpn/ssl.c,
        src/openvpn/ssl_common.h, src/openvpn/ssl_pkt.c,
        src/openvpn/ssl_pkt.h, src/openvpn/tls_crypt.c,
        src/openvpn/tls_crypt.h, tests/unit_tests/openvpn/test_tls_crypt.c.
      + CVE-2025-2704
      [ Fixed upstream in 2.6.14 ]

 -- Lena Voytek <lena.voytek@canonical.com>  Wed, 21 May 2025 13:13:19 -0400
