=== sample/sample-plugins/Makefile ===
--- 
+++ 
@@ -154,7 +154,7 @@
 CCDEPMODE = depmode=gcc3
 CFLAGS = -Wall -Wno-stringop-truncation -g -O2 -std=c99 
 CMOCKA_CFLAGS = 
-CMOCKA_LIBS = -lcmocka
+CMOCKA_LIBS = -lcmocka 
 CPP = gcc -E
 CPPFLAGS = 
 CSCOPE = cscope
@@ -174,6 +174,7 @@
 ETAGS = etags
 EXEEXT = 
 FGREP = /usr/bin/grep -F
+FILECMD = file
 GIT = git
 GREP = /usr/bin/grep
 IFCONFIG = /usr/sbin/ifconfig
@@ -186,13 +187,13 @@
 LD = /usr/bin/ld -m elf_x86_64
 LDFLAGS = 
 LIBCAPNG_CFLAGS = 
-LIBCAPNG_LIBS = -lcap-ng
+LIBCAPNG_LIBS = -lcap-ng 
 LIBNL_GENL_CFLAGS = 
 LIBNL_GENL_LIBS = 
 LIBOBJS = 
 LIBPAM_CFLAGS = 
 LIBPAM_LIBS = -lpam
-LIBS =  -lcap-ng
+LIBS =  -lcap-ng 
 LIBTOOL = $(SHELL) $(top_builddir)/libtool
 LIPO = 
 LN_S = ln -s
@@ -200,8 +201,8 @@
 LT_SYS_LIBRARY_PATH = 
 LZ4_CFLAGS = 
 LZ4_LIBS = 
-LZO_CFLAGS = -I/usr/lzo/lzo
-LZO_LIBS = -llzo2
+LZO_CFLAGS = -I/usr/include/lzo 
+LZO_LIBS = -llzo2 
 MAKEINFO = ${SHELL} '/home/flichtenheld/openvpn/community/openvpn-build/src/openvpn/missing' makeinfo
 MANIFEST_TOOL = :
 MBEDTLS_CFLAGS = 
@@ -213,12 +214,12 @@
 OBJDUMP = objdump
 OBJEXT = o
 OPENSSL_CFLAGS = 
-OPENSSL_LIBS = -lssl -lcrypto
+OPENSSL_LIBS = -lssl -lcrypto 
 OPENVPN_VERSION_MAJOR = 2
 OPENVPN_VERSION_MINOR = 6
-OPENVPN_VERSION_PATCH = .15
+OPENVPN_VERSION_PATCH = .19
 OPTIONAL_CRYPTO_CFLAGS =  
-OPTIONAL_CRYPTO_LIBS =  -lssl -lcrypto
+OPTIONAL_CRYPTO_LIBS =  -lssl -lcrypto 
 OPTIONAL_DL_LIBS = -ldl
 OPTIONAL_INOTIFY_CFLAGS = 
 OPTIONAL_INOTIFY_LIBS = 
@@ -237,13 +238,13 @@
 PACKAGE = openvpn
 PACKAGE_BUGREPORT = openvpn-users@lists.sourceforge.net
 PACKAGE_NAME = OpenVPN
-PACKAGE_STRING = OpenVPN 2.6.15
+PACKAGE_STRING = OpenVPN 2.6.19
 PACKAGE_TARNAME = openvpn
 PACKAGE_URL = 
-PACKAGE_VERSION = 2.6.15
+PACKAGE_VERSION = 2.6.19
 PATH_SEPARATOR = :
 PKCS11_HELPER_CFLAGS = 
-PKCS11_HELPER_LIBS = -lpthread -ldl -lcrypto -lpkcs11-helper
+PKCS11_HELPER_LIBS = 
 PKG_CONFIG = /usr/bin/pkg-config
 PKG_CONFIG_LIBDIR = 
 PKG_CONFIG_PATH = 
@@ -259,7 +260,7 @@
 SELINUX_LIBS = -lselinux
 SET_MAKE = 
 SHELL = /bin/bash
-SOCKETS_LIBS =  -lnsl -lresolv
+SOCKETS_LIBS =  -lresolv
 STRIP = strip
 SYSTEMD_ASK_PASSWORD = /usr/bin/systemd-ask-password
 SYSTEMD_UNIT_DIR = 
@@ -268,9 +269,9 @@
 TAP_WIN_MIN_MAJOR = 9
 TAP_WIN_MIN_MINOR = 9
 TEST_CFLAGS =     -I$(top_srcdir)/include 
-TEST_LDFLAGS =  -lssl -lcrypto   -lcmocka
+TEST_LDFLAGS =  -lssl -lcrypto    -lcmocka 
 TMPFILES_DIR = 
-VERSION = 2.6.15
+VERSION = 2.6.19
 WINDMC = no
 WOLFSSL_CFLAGS = 
 WOLFSSL_INCLUDEDIR = 
@@ -408,3 +409,4 @@
 	list='$(DISTFILES)'; \
 	  dist_files=`for file in $$list; do echo $$file; done | \
 	  sed -e "s|^$$srcdirstrip/||;t" \
+	      -e "s|^$$topsrcdirstrip/|$(top_builddir)/|;t"`; \
