=== debian/watch ===
version=4
https://build.openvpn.net/downloads/releases/ \
(?:|.*/)openvpn(?:[_\-]v?|)(\d[^\s/]*)\.(?:tar\.xz|txz|tar\.bz2|tbz2|tar\.gz|tgz)
