## openvpn 2.7.0~alpha1

=== sample/sample-plugins/Makefile ===
--- 
+++ 
@@ -143,7 +143,7 @@
 DISTFILES = $(DIST_COMMON) $(DIST_SOURCES) $(TEXINFOS) $(EXTRA_DIST)
 ACLOCAL = ${SHELL} '/home/flichtenheld/openvpn/community/openvpn-build/src/openvpn/missing' aclocal-1.16
 AMTAR = $${TAR-tar}
-AM_DEFAULT_VERBOSITY = 1
+AM_DEFAULT_VERBOSITY = 0
 AR = ar
 AS = as
 AUTOCONF = ${SHELL} '/home/flichtenheld/openvpn/community/openvpn-build/src/openvpn/missing' autoconf
@@ -152,9 +152,9 @@
 AWK = gawk
 CC = gcc
 CCDEPMODE = depmode=gcc3
-CFLAGS = -Wall -Wno-stringop-truncation -g -O2 -std=c99 
+CFLAGS = -Wall -Wold-style-definition -Wstrict-prototypes -Wno-stringop-truncation -g -O2 -std=c11
 CMOCKA_CFLAGS = 
-CMOCKA_LIBS = -lcmocka 
+CMOCKA_LIBS = -lcmocka
 CPP = gcc -E
 CPPFLAGS = 
 CSCOPE = cscope
@@ -164,6 +164,7 @@
 DEPDIR = .deps
 DLLTOOL = false
 DL_LIBS = -ldl
+DNS_UPDOWN_TYPE = systemd
 DSYMUTIL = 
 DUMPBIN = 
 ECHO_C = 
@@ -174,7 +175,6 @@
 ETAGS = etags
 EXEEXT = 
 FGREP = /usr/bin/grep -F
-FILECMD = file
 GIT = git
 GREP = /usr/bin/grep
 IFCONFIG = /usr/sbin/ifconfig
@@ -187,13 +187,13 @@
 LD = /usr/bin/ld -m elf_x86_64
 LDFLAGS = 
 LIBCAPNG_CFLAGS = 
-LIBCAPNG_LIBS = -lcap-ng 
+LIBCAPNG_LIBS = -lcap-ng
 LIBNL_GENL_CFLAGS = 
 LIBNL_GENL_LIBS = 
 LIBOBJS = 
 LIBPAM_CFLAGS = 
 LIBPAM_LIBS = -lpam
-LIBS =  -lcap-ng 
+LIBS = 
 LIBTOOL = $(SHELL) $(top_builddir)/libtool
 LIPO = 
 LN_S = ln -s
@@ -201,8 +201,8 @@
 LT_SYS_LIBRARY_PATH = 
 LZ4_CFLAGS = 
 LZ4_LIBS = 
-LZO_CFLAGS = -I/usr/include/lzo 
-LZO_LIBS = -llzo2 
+LZO_CFLAGS = -I/usr/lzo/lzo
+LZO_LIBS = -llzo2
 MAKEINFO = ${SHELL} '/home/flichtenheld/openvpn/community/openvpn-build/src/openvpn/missing' makeinfo
 MANIFEST_TOOL = :
 MBEDTLS_CFLAGS = 
@@ -214,15 +214,19 @@
 OBJDUMP = objdump
 OBJEXT = o
 OPENSSL_CFLAGS = 
-OPENSSL_LIBS = -lssl -lcrypto 
+OPENSSL_LIBS = -lssl -lcrypto
 OPENVPN_VERSION_MAJOR = 2
-OPENVPN_VERSION_MINOR = 6
-OPENVPN_VERSION_PATCH = .19
+OPENVPN_VERSION_MINOR = 7
+OPENVPN_VERSION_PATCH = _alpha1
 OPTIONAL_CRYPTO_CFLAGS =  
-OPTIONAL_CRYPTO_LIBS =  -lssl -lcrypto 
+OPTIONAL_CRYPTO_LIBS =  -lssl -lcrypto
 OPTIONAL_DL_LIBS = -ldl
 OPTIONAL_INOTIFY_CFLAGS = 
 OPTIONAL_INOTIFY_LIBS = 
+OPTIONAL_LIBCAPNG_CFLAGS = 
+OPTIONAL_LIBCAPNG_LIBS = -lcap-ng
+OPTIONAL_LIBNL_GENL_CFLAGS = 
+OPTIONAL_LIBNL_GENL_LIBS = 
 OPTIONAL_LZ4_CFLAGS = 
 OPTIONAL_LZ4_LIBS = 
 OPTIONAL_LZO_CFLAGS = 
@@ -235,16 +239,17 @@
 OTOOL64 = 
 P11KIT_CFLAGS = 
 P11KIT_LIBS = 
+P11TOOL = 
 PACKAGE = openvpn
 PACKAGE_BUGREPORT = openvpn-users@lists.sourceforge.net
 PACKAGE_NAME = OpenVPN
-PACKAGE_STRING = OpenVPN 2.6.19
+PACKAGE_STRING = OpenVPN 2.7_alpha1
 PACKAGE_TARNAME = openvpn
 PACKAGE_URL = 
-PACKAGE_VERSION = 2.6.19
+PACKAGE_VERSION = 2.7_alpha1
 PATH_SEPARATOR = :
 PKCS11_HELPER_CFLAGS = 
-PKCS11_HELPER_LIBS = 
+PKCS11_HELPER_LIBS = -lpthread -ldl -lcrypto -lpkcs11-helper
 PKG_CONFIG = /usr/bin/pkg-config
 PKG_CONFIG_LIBDIR = 
 PKG_CONFIG_PATH = 
@@ -256,11 +261,14 @@
 ROUTE = /usr/sbin/route
 RST2HTML = rst2html
 RST2MAN = rst2man
+SCRIPTDIR = 
 SED = /usr/bin/sed
 SELINUX_LIBS = -lselinux
 SET_MAKE = 
 SHELL = /bin/bash
-SOCKETS_LIBS =  -lresolv
+SOCKETS_LIBS =  -lnsl -lresolv
+SOFTHSM2_MODULE = 
+SOFTHSM2_UTIL = 
 STRIP = strip
 SYSTEMD_ASK_PASSWORD = /usr/bin/systemd-ask-password
 SYSTEMD_UNIT_DIR = 
@@ -268,11 +276,10 @@
 TAP_WIN_COMPONENT_ID = tap0901
 TAP_WIN_MIN_MAJOR = 9
 TAP_WIN_MIN_MINOR = 9
-TEST_CFLAGS =     -I$(top_srcdir)/include 
-TEST_LDFLAGS =  -lssl -lcrypto    -lcmocka 
+TEST_CFLAGS =       -I$(top_srcdir)/include 
+TEST_LDFLAGS =  -lssl -lcrypto  -lcap-ng   -lcmocka
 TMPFILES_DIR = 
-VERSION = 2.6.19
-WINDMC = no
+VERSION = 2.7_alpha1
 WOLFSSL_CFLAGS = 
 WOLFSSL_INCLUDEDIR = 
 WOLFSSL_LIBS = 
@@ -283,7 +290,6 @@
 ac_ct_AR = ar
 ac_ct_CC = gcc
 ac_ct_DUMPBIN = 
-ac_ct_WINDMC = 
 am__include = include
 am__leading_dot = .
 am__quote = 
@@ -327,6 +333,7 @@
 runstatedir = ${localstatedir}/run
 sampledir = $(docdir)/sample
 sbindir = ${exec_prefix}/sbin
+scriptdir = ${pkglibexecdir}
 sharedstatedir = ${prefix}/com
 srcdir = .
 sysconfdir = ${prefix}/etc
@@ -404,9 +411,3 @@
 	$(MAKE) $(AM_MAKEFLAGS) distdir-am
 
 distdir-am: $(DISTFILES)
-	@srcdirstrip=`echo "$(srcdir)" | sed 's/[].[^$$\\*]/\\\\&/g'`; \
-	topsrcdirstrip=`echo "$(top_srcdir)" | sed 's/[].[^$$\\*]/\\\\&/g'`; \
-	list='$(DISTFILES)'; \
-	  dist_files=`for file in $$list; do echo $$file; done | \
-	  sed -e "s|^$$srcdirstrip/||;t" \
-	      -e "s|^$$topsrcdirstrip/|$(top_builddir)/|;t"`; \
